:- module(libclppb,[
	pb_init/0,
	pb_add/1,
	'#='/2,
	'#>='/2,
	'#<='/2,
	'#>'/2,
	'#<'/2
]).

:- use_module(lpbineq).
:- use_module(interface).
:- use_module(library(lists)).
:- ensure_loaded(operators).


pb_add('#='(Left,Right)) :-
	pb_add('#>='(Left,Right)),
	pb_add('#>='(Right,Left)).
pb_add('#>'(Left,Right)) :- pb_add('#>='(Left,Right+1)).
pb_add('#<'(Left,Right)) :- pb_add('#>='(Right,Left+1)).
pb_add('#<='(Left,Right)) :- pb_add('#>='(Right,Left)).
pb_add('#>='(Left,Right)) :-
	collect_coefflits(Left-Right,[],CoeffLits,0,Const),
	Rhs is -Const,
	simply_consistent(CoeffLits,Rhs),
%	format("adding ~w~n",[add_lpbis([lpbi(CoeffLits,Rhs)])]),
	pb_caddlpbis_nobackup([lpbi(CoeffLits,Rhs)]).
