:- module(global_vars,
	  [ cont/2,
	    incr/1,
	    initialize_vars/0,
	    restore_vars/1,
	    save_vars/1,
	    store/2,
	    timer/2
	  ]).


:- use_module(satsrc(thisProlog),[prolog_version/1]).

:-
	(prolog_version(sicstus3) ->
	     ensure_loaded(satsrc(globalbb))
	;
	     ensure_loaded(satsrc(globalcl))
	).

%:-	ensure_loaded(satsrc(globalcl)).




initialize_vars:-
	store(log,[active,passive,proofs,new_active,inconsistent,
		   red_ctr,match_ctr,subsumption_ctr]),
	store(eq_ctr,0),
	store(const_ctr,0),
	store(red_ctr,0),
	store(match_ctr,0),
	store(red_timer,0),
	store(subsumption_ctr,0),
	store(success_sub_ctr,0),
	store(ord,ord(undefinedOrder,_)),
	store(ordered_checks,false).


incr(Ctr):-
	(cont(Ctr,N) ->
	     N1 is N+1
	;
	     N1=1
	),
	store(Ctr,N1).

decr(Ctr):-
	(cont(Ctr,N) ->
	     N1 is N-1
	;
	     N1=0
	),
	store(Ctr,N1).


save_vars([N,M,O,L,C,S,SS,R,RT,MC]):-
	cont(eq_ctr,N),
	cont(const_ctr,M),
	cont(ord,O),
	cont(log,L),
	cont(ordered_checks,C),
	cont(subsumption_ctr,S),
	cont(success_sub_ctr,SS),
	cont(red_ctr,R),
	cont(red_timer,RT),
	cont(match_ctr,MC).

restore_vars([N,M,O,L,C,S,SS,R,RT,MC]):-
	store(eq_ctr,N),
	store(const_ctr,M),
	store(ord,O),
	store(log,L),
	store(ordered_checks,C),
	store(subsumption_ctr,S),
	store(success_sub_ctr,SS),
	store(red_ctr,R),
	store(red_timer,RT),
	store(match_ctr,MC).


timer(Goal,Timer):-
        statistics(runtime,[T1,_]),
	Goal,
	statistics(runtime,[T2,_]),
	cont(Timer,TT1),
	TT2 is TT1+(T2-T1)/1000,
	store(Timer,TT2),
	!.

:- initialize_vars.
