append([],X,X).
append([X|Xs],Ys,[X|Zs]):-
	append(Xs,Ys,Zs).

store(V,E):-
	bb_put(V,E).

cont(V,E):-
	bb_get(V,E).


incr(Ctr):-
	(cont(Ctr,N) ->
	     N1 is N+1
	;
	     N1=1
	),
	store(Ctr,N1)
%	,
%	(Ctr=red_ctr ->
%	    cont(Ctr,M1),
%	    format('~Nred_ctr=~p (cont=~p))',[N1,M1])
%	;
%	    true)
	.
decr(Ctr):-
	(cont(Ctr,N) ->
	     N1 is N-1
	;
	     N1=0
	),
	store(Ctr,N1).

:-dynamic p/1.

/*
loop(0,_,_,_).
loop(N,Log,List,K):-
	N>0,
	incr(x),
	incr(y),
	N1 is N-1,
	length(LK,K),
	append(LK,List,List1),
	assert(p([1,2,3])),
	statistics(local_stack,LS),
	statistics(global_stack,GS),
	statistics(heap,HS),
	findall(S,sublist(List1,S),SL),
	incr(y),
%	lfunctor(List1,0,_),
%	format(Log,'~NLS=~p, GS=~p, H=~p',[LS,GS,HS]),
	loop(N1,Log,SL,K).


lfunctor(L,I,K):-
	functor(L,_,N),
	(N=2,I<100 ->
	    arg(2,L,L2),
	    I1 is I+1,
	    lfunctor(L2,I1,M),
	    K is N+M
	;
	    K=0
	).
*/

loop(0,_,_,_).
loop(N,Log,List,K):-
	N>0,
	incr(x),
	incr(y),
	N1 is N-1,
	assert(p([1,2,3])),
	length(LK,K),
	append(LK,List,List1),
	findall(S,sublist(List1,S),SubLists),
	statistics(local_stack,LS),
	statistics(global_stack,GS),
	statistics(heap,HS),
	incr(y),
	format(Log,'~NLS=~p, GS=~p, H=~p',[LS,GS,HS]),
	flush_output(Log),
	loop(N1,Log,SubLists,K).


sublist(X,_,X).
sublist([_|X],N,Y):-
	N>0,
	N1 is N-1,
	sublist(X,N1,Y).

sublist(X,X).
sublist([_|X],Y):-
	sublist(X,Y).



l(N,K):-
	open('/tmp/log',write,Log),
	abolish(p,1),
	store(x,0),
	store(y,0),
	loop(N,Log,[],K),
	close(Log).

run:-
	cont(k,K),
	K>0,
	!,
	format('~NSetting k=~p~n',[K]),

	on_exception(resource_error(_,memory),
		     l(1000000,K),
		     (   cont(x,XX),
			 cont(y,YY),
			 format('~Nout of memory: x=~p, y=~p',[XX,YY])
		     )
		    ),
	decr(k),
	run.
run.

:- store(k,100).