theory([L1,L2,L3],Thy,Ord):-
	use_module(dp(formulas)),
	X='$VAR'(0),
	Y='$VAR'(1),
%	Z='$VAR'(2),
	
	mk_equation(car(cons(X,Y)),X,o,axiom(1),L1),
	mk_equation(cdr(cons(X,Y)),Y,o,axiom(2),L2),
	mk_equation(cons(car(X),cdr(X)),X,o,axiom(3),L3),
	
	Sig=sig([car:([o]->o),
		 cdr:([o]->o),
		 cons:([o,o]->o),
		 a:([]->o),
		 b:([]->o),
		 c:([]->o),
		 d:([]->o),
		 e:([]->o),
		 f:([]->o),
		 g:([]->o)
		],
		cons([cons])),
	Thy=equational(Sig,_Rs),
	Ord=ord(lpoc,prec([],[car,cdr],[a,b,c,d,e,f,g],[cons])).




goal1:-
	mk_equation(cons(a,b),c,o,axiom(4),E1),
	mk_equation(cons(d,e),a,o,axiom(5),E2),
	mk_equation(d,c,o,axiom(6),E3),   % unsatisfiable
	mk_equation(d,e,o,axiom(7),E4),   % ok
	mk_equation(cons(f,g),cons(a,b),o,axiom(8),E5),
	theory([L1,L2,L3],Thy,Ord),
	hgstuff:time(saturation:sat(Thy,Ord,
				 [L1,L2,L3],
				 [E1,E2,E3,E5],
				 _A,_P),
		    T),
	format('~2nTime: ~p~2n',[T]).


goal2:-
	mk_equation(car(a),b,o,axiom(4),E6),
	mk_equation(car(c),a,o,axiom(5),E7),
	mk_equation(cons(b,g),cons(c,b),o,axiom(6),E8),
	theory([L1,L2,L3],Thy,Ord),
	hgstuff:time(saturation:sat(Thy,Ord,
				 [L1,L2,L3],
				 [E6,E7,E8],
				 _A,_P),
		    T),
	format('~2nTime: ~p~2n',[T]).


goal3:-
	mk_equation(cons(a,b),c,o,axiom(4),E1),
	mk_equation(cons(d,e),a,o,axiom(5),E2),
	mk_equation(d,c,o,axiom(6),E3),   % unsatisfiable
	mk_equation(d,e,o,axiom(7),E4),   % ok
	mk_equation(cons(f,g),cons(a,b),o,axiom(8),E5),
	theory([L1,L2,L3],Thy,Ord),
	hgstuff:time(saturation:sat(Thy,Ord,
				 [L1,L2,L3],
				 [E1,E2,E4,E5],
				 _A,_P),
		    T),
	format('~2nTime: ~p~2n',[T]).


