:- module(log,[log/2]).


:- use_module(global_vars, [
		       cont/2,
		       store/2
   ]).
:- use_module(library(basics), [
		       member/2
   ]).



/* ------------------------------------------------------------------------------

 logging
 
------------------------------------------------------------------------------ */




log(Event,Params):-
	cont(log,Events),
	member(Event,Events),
	!,
	message(Event,M),
	format(M,Params).
log(_Event,_Params).



message(active,'~2nActive equations ~n~p~2n').
message(passive,'~2nPassive equations ~n~p~2n').
message(proofs,'~2nProofs ~n~p~2n').
message(select_active,'~Nselect ~p').
message(normalized_active,'~Nselection normalized to ~p').
message(new_active,'~Nnew active ~p').
message(redundant,'~Nredundant ~p').
message(red_by_orw,'~Nredundant by orw ~p').
message(red_ctr,'~NNumber of reductions = ~p').
message(subsumption_ctr,'~NNumber of subsumption checks [successful] = ~p [~p]').
message(reducible_rules,'~Nreducible (by ~p) rules ~n~p').
message(new,'~Nnew ~n~p').
message(nonredundant_new,'~Nnormalized nonredundant new ~n~p').
message(current_rules,'~Ncurrent rules ~n~p').
message(current_eqs,'~Ncurrent equations ~n~p').
message(orphan,'~Norphan ~p (proof = ~p)').
message(inconsistent,'~Ninconsistency found ~p').





