:- module(global,
	  [ cont/2,
	    current_vars/1,
	    destroy/1,
	    incr/1,
	    initialize_vars/0,
	    initialize_theory_vars/0,
	    set_vars/1,
	    store/2,
	    spy_clause/1
	  ]).


:-dynamic 
	spy_clause/1.


:- use_module(thisProlog,[prolog_version/1]).


:-
	(prolog_version(sicstus3) ->
	     ensure_loaded(globalbb)
	;
	     ensure_loaded(globalcl)
	).


current_vars([V,IV,SC,SkC,PC,FC,PredC,RC,NR]):-
	cont(var_depth,V),
	cont(inc_var_depth_now,IV),
	cont(selCtr,SC),
	cont(skolemCtr,SkC),
	cont(propCtr,PC),
	cont(funcCtr,FC),
	cont(predCtr,PredC),
	cont(rewriteCtr,RC),
	cont(new_rules,NR).
	
set_vars([V,IV,SC,SkC,PC,FC,PredC,RC,NR]):-
	store(var_depth,V),
	store(inc_var_depth_now,IV),
	store(selCtr,SC),
	store(skolemCtr,SkC),
	store(propCtr,PC),
	store(funcCtr,FC),
	store(predCtr,PredC),
	store(rewriteCtr,RC),
	store(new_rules,NR).
	

initialize_vars:-
	% executed upon cl
	% and upon starting a saturation
	props:initial_var_depth(D),
	store(var_depth,D),
	store(inc_var_depth_now,50),
	store(selCtr,0),
	store(rewriteCtr,0),
	store(new_rules,[]).

initialize_theory_vars:-
	% executed upon cl
	store(propCtr,0),
	store(funcCtr,0),
	store(predCtr,0),
	store(skolemCtr,0).

incr(Ctr):-
	(cont(Ctr,N) ->
	     N1 is N+1
	;
	     N1=1
	),
	store(Ctr,N1).

decr(Ctr):-
	(cont(Ctr,N) ->
	     N1 is N-1
	;
	     N1=0
	),
	store(Ctr,N1).


:-
	% global initializations
	store(ct,[]).   % empty ``current theory''