exception Beta_Redex;

val parens = enclose "(" ")" o space_implode " ";

fun lisp (Abs(x, T, b)) =
      let val x' = variant (add_term_names (b, [])) x
      in parens ["\\", x', lisp (subst_bound (Free (x', T), b))] end
  | lisp (Const (c, _)) = quote c
  | lisp (Free (x, _)) = x
  | lisp (Var(xi, _)) = Syntax.string_of_vname xi
  | lisp (tm as _ $ _) =
      let val (func,args) = strip_comb tm
      in case func of Abs _ => raise Beta_Redex
         | _ => parens (lisp func :: map lisp args)
      end;

(* print_lisp_tac i prints subgoal i;
   my_tac should be relaced by a sensible tactic,
   e.g. calling Bliksem and feeding the result back into Isabelle.
*)
fun my_tac i = no_tac;
val print_lisp_tac = SUBGOAL (fn (t, i) => (writeln (lisp t); my_tac i));

