/*



     Term Expansion
     mainly for handling OO stuff




Bug:
map expansion gets confused if use_module goals
follow maplist goals, generating the map predicates
in the wrong module.


*/


:- use_module(mylists,[reverse/2,is_list/1]).
:- use_module(auxiliary,[appendAtoms/3]).
:- use_module(library(sets),[select/3]).
:- use_module(library(maplist),[maplist/2,maplist/3,scanlist/4]).
:- use_module(thisProlog,[prolog_version/1]).


:- dynamic dontExpand/0, expand_debug/0, aux_clause/1, aux_ctr/1.


aux_ctr(0).



new(N):-
	retract(aux_ctr(N)),
	N1 is N+1,
	assert(aux_ctr(N1)).



:- multifile  
	term_expansion/2.

:- 
	prolog_version(V),
	format('~n***Expanding for ~p',[V]),
	nl,
	ttyflush.

termExpansion(_X==end_of_file,_):-
	!,
	fail.
termExpansion(end_of_file,AuxClauses):-
%  that hack needs to be changed since end_of_file
%  can occur elsewhere too
	findall(C,aux_clause(C),ACs),
	ACs\==[],
	retractall(aux_clause(_)),
%	write(ACs),nl,
        append(ACs,[end_of_file],AuxClauses).

termExpansion((:-mymultifile Ps),M):-
	nonvar(Ps),
	(prolog_version(sicstus) ->
	     M= (:- true)
	;    
	     M= (:- multifile Ps)
	).
termExpansion(hash_term(T,K),user:term_hash(T1,100000,10000000,K1)):-
	(  prolog_version(sicstus)
	;  prolog_version(sicstus3)
	),
	expand_term(T,T1),
	expand_term(K,K1).
termExpansion(Mo:maplist(P,L1,L2),M):-
%	trace,
	nonvar(P),
	P=..[F|Args],
	length(Args,N),
	length(ExtraArgs,N),
%	new(C),
	appendAtoms([map,F],'$',FM),
	M=..[FM,L1,L2|Args],
	Mempty=..[FM,[],[]|ExtraArgs],
	(aux_clause(Mempty) ->
	     true
	;
	     Mcons=..[FM,[X|Xs],[Y|Ys]|ExtraArgs],
	     Mtail=..[FM,Xs,Ys|ExtraArgs],
	     append(ExtraArgs,[X,Y],AllArgs),
	     Pcall=..[F|AllArgs],
%	     write(Mempty),nl,
%	     write((Mcons :- Mo:Pcall, Mtail)),nl,
	     assertz(aux_clause(Mempty)),
	     assertz(aux_clause((Mcons :- Mo:Pcall, Mtail)))
	).
termExpansion(maplist(P,L1,L2),M):-
%	trace,
	nonvar(P),
	P=..[F|Args],
	length(Args,N),
	length(ExtraArgs,N),
%	new(C),
	appendAtoms([map,F],'$',FM),
	M=..[FM,L1,L2|Args],
	Mempty=..[FM,[],[]|ExtraArgs],
	(aux_clause(Mempty) ->
	     true
	;
	     Mcons=..[FM,[X|Xs],[Y|Ys]|ExtraArgs],
	     Mtail=..[FM,Xs,Ys|ExtraArgs],
	     append(ExtraArgs,[X,Y],AllArgs),
	     Pcall=..[F|AllArgs],
%	     write(Mempty),nl,
%	     write((Mcons :- Pcall, Mtail)),nl,
	     assertz(aux_clause(Mempty)),
	     assertz(aux_clause((Mcons :- Pcall, Mtail)))
	).
termExpansion(Mod:maplist(P,L1),M):-
	!,
%	trace,
	nonvar(P),
	P=..[F|Args],
	length(Args,N),
	length(ExtraArgs,N),
	appendAtoms([map,F],'$',FM),
	M=..[FM,L1|Args],
	Mempty=..[FM,[]|ExtraArgs],
	(aux_clause(Mempty) ->
	     true
	;
	     Mcons=..[FM,[X|Xs]|ExtraArgs],
	     Mtail=..[FM,Xs|ExtraArgs],
	     append(ExtraArgs,[X],AllArgs),
	     Pcall=..[F|AllArgs],
%	     write(Mempty),nl,
%	     write((Mcons :- Mod:Pcall, Mtail)),nl,
	     assertz(aux_clause(Mempty)),
	     assertz(aux_clause((Mcons :- Mod:Pcall, Mtail)))
	).

termExpansion(maplist(P,L1),M):-
%	trace,
	nonvar(P),
	P=..[F|Args],
	length(Args,N),
	length(ExtraArgs,N),
	appendAtoms([map,F],'$',FM),
	M=..[FM,L1|Args],
	Mempty=..[FM,[]|ExtraArgs],
	(aux_clause(Mempty) ->
	     true
	;
	     Mcons=..[FM,[X|Xs]|ExtraArgs],
	     Mtail=..[FM,Xs|ExtraArgs],
	     append(ExtraArgs,[X],AllArgs),
	     Pcall=..[F|AllArgs],
%	     write(Mempty),nl,
%	     write((Mcons :- Pcall, Mtail)),nl,
	     assertz(aux_clause(Mempty)),
	     assertz(aux_clause((Mcons :- Pcall, Mtail)))
	).

termExpansion(M:App,M:append(A1,B1,C1)):-
	atom(M),
	nonvar(App),
	App=append(A,B,C),
	expand_term(A,A1),
	expand_term(B,B1),
	expand_term(C,C1).
termExpansion(append(A,B,C),user:append(A1,B1,C1)):-
	expand_term(A,A1),
	expand_term(B,B1),
	expand_term(C,C1).
termExpansion(unix(A),user:unix(A1)):-
	expand_term(A,A1).
termExpansion(M:Sub,M:subsumes_chk(A1,B1)):-
	atom(M),
	nonvar(Sub),
	Sub=subsumes_chk(A,B),
	expand_term(A,A1),
	expand_term(B,B1).
termExpansion(subsumes_chk(A,B),user:subsumes_chk(A1,B1)):-
	expand_term(A,A1),
	expand_term(B,B1).
termExpansion((:-use_module(user,_,Imports)),(:-use_module(user,_,Imports1))):-
	((prolog_version(sicstus);prolog_version(sicstus3)),
	 select(append/3,Imports,Imports1) ->
	     true
	;
	     Imports=Imports1
	).
termExpansion((:-use_module(thisProlog,Imports)),(:-use_module(thisProlog,Imports1))):-
	(prolog_version(sicstus),select(time_out/3,Imports,Imports1) ->
	     true
	;
	     Imports=Imports1
	).
termExpansion(invariant(C,[M,P]),D):-
	(expand_debug ->
	     expand_term(C,C1),
	     D=(C1 -> format(M,P),trace ; true)
	;
	     D=true
	).
termExpansion(T,T1):-
	T=..[F|Ts],
	expand_terms(Ts,Ts1),
	T1=..[F|Ts1].

expand_terms([T|Ts],[E|Es]):-
	expand_term(T,E),
	expand_terms(Ts,Es).
expand_terms([],[]).



% instanceVariables(+C,?IV1, ?IV2)
% is true when IV1 and IV2 are two copies of the instance variable structure of
% objects of class C. These are represented by difference lists
instanceVariables(C,IV-Last,IV1-Last1):-
	classDefinition(C,S,_IVC,_Methods),
%	length(_IVC,M),
%	length(CopyIVC,M),
%	CVars=..[C|CopyIVC],
	CVars=..[C,_],
	(nonvar(S) ->
	     instanceVariables(S,IV-[CVars|Last],IV1-[CVars|Last1])
	;    
	IV=[CVars|Last],
	IV1=[CVars|Last1]
	).



% finally

:- dynamic trace_expansion/0.

term_expansion(In,In):-
	nonvar(In),
	In=(:-Goal),
	var(Goal),
	!.
term_expansion(In,Out):-
	\+ dontExpand,
	(trace_expansion -> trace; true),
	termExpansion(In,Out1),
	% now do the standard expansions
	assert(dontExpand),
	expand_term(Out1,Out),
	retract(dontExpand).


