/*
:- module(qTheory, [
      
        currentTheory/1,
	equal/2,
	match/2,
	match/4,
        mgu/2,
	unifiable/2,
	unify/2

     ]).
/*

/*
   this module provides the basic operations
   for solving linear equational constraints
   over the rational numbers.
*/



:- use_module(uniac,[ac_uniAC/2]).

:- use_module(match,[ac_match_pt/2,ac_match/4]).

:- use_module(aclpo,[cEqual/2]).


currentTheory(q).


equal(A,B):-
	cEqual(A,B).

match(A,B):-
	ac_match_pt(A,B).

match(A,B,C,D):-
	ac_match(A,B,C,D).

%mgu(_A,_B):-
%	raise_exception(mgu_not_implemented_for_C).

% partial imlementation:
mgu([],[]).
mgu([A=B|E],[]):-
	mgu(A=B,_),
	mgu(E,_).
mgu(A=B,[]):-
	cEqual(A,B).



unifiable(A,B):-
	\+ \+ ac_uniAC(A,B).

unify(A,B):-
	ac_uniAC(A,B).
