

:- use_module(library(date), [
	date_and_time/2
   ]).

:- use_module(library(files), [
	file_exists/1
   ]).

:- use_module(library(environ), [
	expanded_file_name/2
   ]).

:- use_module(library(pipe), [
	popen/3
   ]).

:- use_module(global,[store/2]).


:- user:add_search_path(slibrary,satsrc(slib)),
   user:add_search_path_at_end(library,satsrc(plib)).


compile_nqa(M,F):-
	assertz(user:query_hook(yes_no_proceed,_,_,_,_,proceed),Ref),
	assertz(user:message_hook(_,informational,_),Ref1),
	no_style_check(discontiguous),
	no_style_check(single_var),
	M:compile(F),
	style_check(single_var),
	style_check(discontiguous),
	erase(Ref),
	erase(Ref1).

shell(C):-
	unix(shell(C)).


command_exists(Command) :-
	name(Command,NCommand),
	append("which ",NCommand,NWCommand0), % we need the command which
	% and redirect stderr to /dev/null
%	append(NWCommand0, " ",NWCommand),
	append(NWCommand0, " 2> /dev/null ",NWCommand),
	name(WCommand,NWCommand),
	% which writes nothing to stdout if the command not exists
	popen(WCommand,read,Stream),
	get0(Stream,Res),
	close(Stream),!, % don't backtrack over close
	Res \== -1. % if not found stdout is end of file



% Quintus specific settings

gen_tmp_file(F,TempFile):-
	auxiliary:appendAtoms(['/tmp/sat',F,'$$'],'_',TF),
	expanded_file_name(TF,TempFile).

gen_tmp_files:-
	expanded_file_name('/tmp/sat_int_flags_$$',IF),
	expanded_file_name('/tmp/sat_defaults_$$',DF),
	expanded_file_name('/tmp/sat_props_$$',PF),
	store(int_flags_tmp_file,IF),
	store(defaults_tmp_file,DF),
	store(props_tmp_file,PF).


tmp_file(F,TF):-
	name(F,FN),
	append("/tmp/sat$$",FN,TFN),
	name(F1,TFN),
	expanded_file_name(F1,TF).


save_state:-
	nl, nl, write( 'File to save Saturate on: '), 
	read( Name ),
	(Name=d ->
	     Na = '/HG/usr/hg/bin/SunOS4/sat5'
	;Name=ds ->
	     Na = '/HG/usr/hg/bin/solaris/sat5'
	;
	     Na=Name),
	save_state(Na).

save_state(Na):-
	date_and_time(date(Y,M,D),Time),
	% SICStus =< 3.3 is year 2000 buggy
	(Y<2000 ->
	    Y1 is 2000+Y-100
	;
	    Y1 = Y),
	D1=date(Y1,M,D),
	retractall(savedOn(_,_)),
	assert(savedOn(D1,Time)),
	save_program( Na, user:start ),
	user:start,
	!.

time_out(C,_T,A):-
	C,
	A=success.


user:sqrt(S,R):-
	R is S/4.  % uff
