% SICStus specific settings



% SICStus QUINTUS compatibility


user:append([], List, List).
user:append([Head|Tail], List, [Head|Rest]) :- 
        user:append(Tail, List, Rest).

user:no_style_check(single_var) :- prolog_flag(single_var_warnings,_,off),!.
user:no_style_check(_other). % haben wir nicht in SICStus
user:style_check(single_var) :- prolog_flag(single_var_warnings,_,on),!.
user:style_check(_other).

command_exists(_).


file_exists(F):-
	on_exception(E,
		     open(F,read,_S),
		     \+ notARegularFile(E)
		    ).


%notARegularFile(permission_error(_,_,_,_,'No such file or directory')).
%notARegularFile(permission_error(_,_,_,_,'Is a directory')).
notARegularFile(_).  % we simply assume that any exception is due to
                     % the nonexistence of the file

:-
	user:saturate_directory( P ),
	name(P,PN),
	user:append(PN,"/sources/plib",PSN),
	name(PS,PSN),
	asserta(user:library_directory(PS)).
%	assertz(user:library_directory('/HG/local/languages/q3.1.1/generic/qplib3.1.1/library')).






:- use_module(date, [
	date_and_time/2
   ]).

:- use_module(global,
	      [store/2]).



compile_nqa(M,F):-
	(prolog_version(sicstus) ->
		     my_absolute_file_name(F,FA)
	;
		     absolute_file_name(F,FA)
	),

	prolog:'$multiple_flag'(FL,off),
	assertz(user:portray_message(informational,_),Ref1),
	M:compile(FA),
	prolog:'$multiple_flag'(_,FL),
	erase(Ref1).

gen_tmp_file(F,TempFile):-
	auxiliary:appendAtoms(['/tmp/sat',F,'XXXXXX'],'_',TF),
	prolog:'$unix_mktemp'(TF,TempFile).

gen_tmp_files:-
	prolog:'$unix_mktemp'('/tmp/sat_int_flags_XXXXXX',IF),
	prolog:'$unix_mktemp'('/tmp/sat_defaults_XXXXXX',DF),
	prolog:'$unix_mktemp'('/tmp/sat_props_XXXXXX',PF),
	store(int_flags_tmp_file,IF),
	store(defaults_tmp_file,DF),
	store(props_tmp_file,PF).

save_state:-
	nl, nl, write( 'File to save Saturate on: '), 
	read( Name ),
	(Name=d ->
	     Na = '/HG/usr/hg/bin/SunOS4/sat62'
	;Name=ds ->
	     Na = '/HG/usr/hg/bin/solaris/sat62'
	;
	     Na=Name),
	save_state(Na).

save_state(Na):-
	date_and_time(Date,Time),
	retractall(savedOn(_,_)),
	assert(savedOn(Date,Time)),
	save( Na ),
	user:start,
	!.


user:sqrt(S,R):-
	R is sqrt(S).
