% SICStus 3.X specific settings
% some of this is the same as for SICStus 2.1



% SICStus QUINTUS compatibility


user:append([], List, List).
user:append([Head|Tail], List, [Head|Rest]) :- 
        user:append(Tail, List, Rest).

user:no_style_check(single_var) :- prolog_flag(single_var_warnings,_,off),!.
user:no_style_check(_multiple). % haben wir nicht in SICStus
user:style_check(single_var) :- prolog_flag(single_var_warnings,_,on),!.
user:style_check(_multiple).

command_exists(_).


shell(C):-
	system:shell(C).

%:-
%	user:add_search_path(library,satsrc(plib)).



:- use_module(library(system),
	      [file_exists/1,mktemp/2,system/1,datime/1,working_directory/2]).

/*
:-
	(user:os(windows) ->
	    ensure_loaded(timeout)
	;
	    use_module(library(timeout),[time_out/3])
	).
*/



:- use_module(library(timeout),[time_out/3]).

:- use_module(global,
	      [store/2]).




user:subsumes_chk(General, Specific) :-
	var(General),
	var(Specific), !.
user:subsumes_chk(General, Specific) :-
	nonvar(Specific),
	\+ \+ prolog:'$subsumes'(General, Specific).



user:term_hash(Term, Depth, Range, Value) :-
	(   integer(Depth), Depth >= -1 -> true
	;   illarg(domain(integer,>=(-1)),
	           user:term_hash(Term,Depth,Range,Value), 2)
	),
	(   integer(Range), Range >= 1 -> true
	;   illarg(domain(integer,>=(1)),
	           user:term_hash(Term,Depth,Range,Value), 3)
	),
	prolog:'$term_hash'(Term, Depth, Range, Value).



compile_nqa(M,F):-
	on_exception(domain_error(_,_,_,_),           % SICStus
		     absolute_file_name(F,FA),
		     my_absolute_file_name(F,FA)),
	prolog:'$multiple_flag'(FL,off),
	assertz(user:portray_message(informational,_),Ref1),
	assertz(user:portray_message(warning,_),Ref2),
	M:compile(FA),
	prolog:'$multiple_flag'(_,FL),
	erase(Ref1),
	erase(Ref2).

gen_tmp_file(F,TempFile):-
	user:os(windows),
	!,
	auxiliary:appendAtoms(['c:/tmp/sat',F,'XXXXXX'],'_',TF),
	mktemp(TF,TempFile).
gen_tmp_file(F,TempFile):-
	auxiliary:appendAtoms(['/tmp/sat',F,'XXXXXX'],'_',TF),
	mktemp(TF,TempFile).



gen_tmp_files:-
	user:os(windows),
	!,
	mktemp('c:/tmp/sat_int_flags_XXXXXX',IF),
	mktemp('c:/tmp/sat_defaults_XXXXXX',DF),
	mktemp('c:/tmp/sat_props_XXXXXX',PF),
	store(int_flags_tmp_file,IF),
	store(defaults_tmp_file,DF),
	store(props_tmp_file,PF).
gen_tmp_files:-
	mktemp('/tmp/sat_int_flags_XXXXXX',IF),
	mktemp('/tmp/sat_defaults_XXXXXX',DF),
	mktemp('/tmp/sat_props_XXXXXX',PF),
	store(int_flags_tmp_file,IF),
	store(defaults_tmp_file,DF),
	store(props_tmp_file,PF).

save_state:-
	nl, nl, write( 'File for saving image: '),
	ttyflush,
	read( Name ),
	(Name=dl ->
	     Na = '/HG/usr/hg/bin/linux/sat6'
	;Name=ds ->
	     Na = '/HG/usr/hg/bin/solaris/sat6'
	;Name=dw ->
	     Na = 'c:/opt/cygwin/home/hg/bin/sat6'
	;
	     Na=Name),
	write('saving to '), write(Na), nl,
	save_state(Na).




save_state(Na):-
	datime(datime(Y,M,D,H,Mi,S)),
	retractall(savedOn(_,_)),
	M1 is M-1,       % compatibility with Quintus date.c
	assert(savedOn(date(Y,M1,D),time(H,Mi,S))),
	on_exception(existence_error(save_program(_,_),_,_,_,_),
	             save_program( Na, user:start ),  % doesn't exist in versions < 3.7
		     (save_program(Na),	user:start)
		     ).


/*

:- initialization(( 
%		  thisProlog:load(library(system)),
%		  libclppb:compile(satsrc('CLPPB/interface')),
		  user:start
		  )
		 ).


*/



%time_out(C,_T,A):-
%	C,
%	A=success.

user:unix(cd(D)):-
	working_directory(_,D).
user:unix(system(C)):-
	os:unix2os(C,C1),
	system(C1).
user:unix(shell(C)):-
	os:unix2os(C,C1),
	shell(C1).



user:sqrt(S,R):-
	R is sqrt(S).
