% vars.pl
% pb
% handling of variables

:- module(vars,[
	varassoc/4,
	var_union/3,
	var_setminus/3,
	var_memberchk/2
]).

% varassoc(V0,V1,T0,T1).
% takes a list of V-W pairs V0 and searches for an
% entry where V = T0. If yes, then W = T1 and V0 = V1.
% Else a new entry T0-T1 is append on V0 yielding V1.
varassoc([],[T0-T1],T0,T1).
varassoc([V-W|V0],[V-W|V1],T0,T1) :-
	(V == T0 ->
	    V0 = V1,
	    T1 = W
	;
	    varassoc(V0,V1,T0,T1)
	).
	    
var_memberchk(V0,[V1|Vars]) :-
	(V0 \== V1 ->
	    var_memberchk(V0,Vars)
	;
	    true
	).
	    
var_union([],V,V).
var_union([V0|Vars0],Vars1,Vars2) :-
	var_memberchk(V0,Vars1),!,
	var_union(Vars0,Vars1,Vars2).
var_union([V0|Vars0],Vars1,[V0|Vars2]) :-
	var_union(Vars0,Vars1,Vars2).

var_setminus([],_,[]).
var_setminus([V0|Vars0],Vars1,Vars2) :-
	var_memberchk(V0,Vars1),!,
	var_setminus(Vars0,Vars1,Vars2).
var_setminus([V0|Vars0],Vars1,[V0|Vars2]) :-
	var_setminus(Vars0,Vars1,Vars2).


	
