%%%% not needed anymore. windows versions can also be generated
%%%% by compiling sat.pl
/* -----------------------------------------------------------------------

Installation steps:

1. Edit ``saturate_directory'' below to where you have unloaded the system.
2. cd to the sources subdirectory.
3. Call Prolog.
4. Generate Saturate by saying

?- compile(sat), genSystem.

5. At the end you'll be asked for the name of a file
on which the system is to be saved.
Write file names that are no Prolog atoms with quotes
such as in the example below and put a dot ``.'' at the end.

6. Start using Saturate right away or exit by typing ^D.
Subsequently you call Saturate by executing the saved file.


-------------------------------------------------------------------------*/


            % change these definitions appropriatetely

                   


% Saturate home directory:
saturate_directory( 'u:/saturate' ).  




% definitions for how to call the WWW browser

% the following facts specify commands in the form of lists of atoms
% that are to be concatenated and then called.
% ``URL'' is a place holder for where the
% URL should be placed in the command.

% command for starting a new browser
html_browser(startup(URL),['explorer  ',URL]). 

% test for checking whether browser is running 
html_browser(already_running,['xprop -name Netscape 1> /dev/null 2> /dev/null']).

% command for informing the running browser to display a URL:
html_browser(inform(URL),['netscape -remote ''openURL(',URL,')''']).


% operating system
% for windows use wsat

os(windows).




davis_putnam( no ) :-
	\+ os(solaris),
	!.
davis_putnam( yes ):-
	os(solaris).
			   % change to ``no''
                           % if the pseudo-boolean constraint solver
                           % should not be included into solaris versions

                           % only effective for SICStus 3.x
                           % turn off (``no'') in case of compilation problems
                           


%==============================================================================

            % you're not supposed to change anything from here on

%==============================================================================


saturate_version('2.8').




:- op(1150,fx,mymultifile).



:- op(1020,xfx,if).
:- op(940,yfx,[and,'&']).
:- op(930,yfx,[or,'|']).
:- op(950,xfx,[<=>]).
:- op(950,xfy,[=>]).
%:- op(900,fy,[~,dia,box]).
:- op(900,fy,[dia,box]).
:- op(700,yfx,@).    % apply operator
:- op(500,fy,[~]).   % should be smaller than :
:- op(600,yfx,[::]).
:- op(600,xfx,[^^]).
:- op(100,fx,[!,?]).
:-op(1050,xfx,<-).
:-op(1150,fx,goal).





:- multifile  
	portray/1,
	file_search_path/2, 
	query_hook/6, 
	message_hook/3, 
	portray_message/2.

:- dynamic 
	file_search_path/2, 
	query_hook/6, 
	message_hook/3, 
	portray_message/2,
	spy_clause/1,
	user_portray/1,
	no_portray/0.





add_search_path(Name,P):-
	file_search_path(Name,P),
	!.
add_search_path(Name,P):-
	asserta(file_search_path(Name,P)).

add_search_path_at_end(Name,P):-
	file_search_path(Name,P),
	!.
add_search_path_at_end(Name,P):-
	assertz(file_search_path(Name,P)).




message_hook(_,help,_).


unknown_predicate_handler(_,dynamicCode,fail).


 
% SICStus has no built-in append

append1([], List, List).
append1([Head|Tail], List, [Head|Rest]) :- 
	append1(Tail, List, Rest).


:-
	add_search_path(library,satsrc(plib)),
	saturate_directory( P ),
	add_search_path(sathome,P),
	name(P,PN),
	append1(PN,"/sources",PSN),
	name(PS,PSN),
	add_search_path(satsrc,PS).



:- use_module(mylists,[is_list/1]).


portray(X):-
	var(X),
	!,
	fail.
portray(date(Y,M,D)):-
	format('~d ~p ~p',[D,month(M),Y]).
portray(time(H,M,S)):-
	format('~d:~p:~p',[H,dig2(M),dig2(S)]).
portray(dig2(Z)):-
	Z1 is Z mod 100,
	(Z1<10 -> write(0)
	;true),
	write(Z1).
portray('$list'([])).
portray('$list'([X])):-
       !,
       print(X).
portray('$list'([X|Xs])):-
	print(X),
	write(','),
	print('$list'(Xs)).
%       format('~p,~p',[X,'$list'(Xs)]).
portray(month(0)):-write('January').
portray(month(1)):-write('February').
portray(month(2)):-write('March').
portray(month(3)):-write('April').
portray(month(4)):-write('May').
portray(month(5)):-write('June').
portray(month(6)):-write('July').
portray(month(7)):-write('August').
portray(month(8)):-write('September').
portray(month(9)):-write('October').
portray(month(10)):-write('November').
portray(month(11)):-write('December').
portray(atoms([])):-write([]).
portray(atoms([A])):-write(A).
portray(atoms([A,B|As])):-write(A),write(','),print(atoms([B|As])).
portray('$all'(_SkT,V,B)):-
	\+ no_portray,
	combine_qu('$all'(_SkT,V,B),Vs,Body),
	format('!~p.(~p)',['$list'(Vs),Body]).
portray('$exists'(_SkT,V,B)):-
	\+ no_portray,
	combine_qu('$exists'(_SkT,V,B),Vs,Body),
	format('?~p.(~p)',['$list'(Vs),Body]).
portray('$lambda'(_SkT,V,B)):-
	\+ no_portray,
	combine_qu('$lambda'(_SkT,V,B),Vs,Body),
	format('(\\~p.~p)',['$list'(Vs),Body]).
portray('$apply'(F,A)):-
	\+ no_portray,
	format('~p(~p)',[F,A]).
portray(Lit):-
	is_list(Lit),
	length(Lit,5),
	Lit=[P,_,R,S,T],
	(P== '-' ->
	     write('~')
	;P== '+' ->
	     true
	),
	L=..[R,S,T],
	print(L).
%portray('$VAR'(I)):-
%	format('X~d',[I]).
portray('$min'):-
	print(min).
portray(X):-
	user_portray(X).



combine_qu('$all'(_SkT,V,'$all'(_,V1,B)),[V|Vs],Body):-
	!,
	combine_qu('$all'(_,V1,B),Vs,Body).
combine_qu('$all'(_,V,B),[V],B).
combine_qu('$exists'(_SkT,V,'$exists'(_,V1,B)),[V|Vs],Body):-
	!,
	combine_qu('$exists'(_,V1,B),Vs,Body).
combine_qu('$exists'(_,V,B),[V],B).
combine_qu('$lambda'(_SkT,V,'$lambda'(_,V1,B)),[V|Vs],Body):-
	!,
	combine_qu('$lambda'(_,V1,B),Vs,Body).
combine_qu('$lambda'(_,V,B),[V],B).






%==============================================================================
%  k	: compile a file in the source directory
%==============================================================================

k:-     write(' File: '), read(F), nl,
	(retract(user:dontExpand);true),
	( F = dec  -> dir_compile_sources( adt_declarations           ); 
          F = his  -> dir_compile_sources( adt_history                ); 
         F = pre  -> dir_compile_sources( adt_precedence             ); 
         F = fla  -> dir_compile_sources( adt_flag                   ); 
         F = ter  -> dir_compile_sources( adt_term                   ); 
         F = ato  -> dir_compile_sources( adt_atom	               ); 
         F = auxiliary  -> dir_compile_sources( auxiliary                        ); 
         F = clp  -> dir_compile_sources( clause_processing          ); 
         F = crp  -> dir_compile_sources( clause_redundancy_prover   ); 
         F = com  -> dir_compile_sources( commands                   );
         F = ico  -> dir_compile_sources( inference_computation      ); 
         F = iru  -> dir_compile_sources( inference_rules            ); 
         F = inp  -> dir_compile_sources( input                      ); 
         F = out  -> dir_compile_sources( output                     ); 
         F = inp  -> dir_compile_sources( input                      ); 
         F = sat  -> dir_compile_sources( sat                        ); 
         F = tim  -> dir_compile_sources( timing                     ); 
	              dir_compile_sources( F )
	),!.

dir_compile_sources( F ):-
	thisProlog:compile_nqa( user, satsrc(F) ).


%==============================================================================
%  start : welcome message, install defaults and initialize
%==============================================================================



start:- %display_help_file( welcome ),
	!,
	savedOn(D,T),
	prolog_version(P),
	saturate_version(V),
	format('~2nSaturate Version ~p (~p) of ~p at ~p.~2n',[V,P,D,T]),
	gen_tmp_files,
	set_default_flags_as_on_flags.



restart:- 
	display_help_file( welcome ),
	l.



%==============================================================================
%  svst	: SaVe the STate
%==============================================================================

svst:-	
	save_state.





genSystem:-
	compileAll,
	svst,
	start.

genSystem(S):-
	compileAll,
	save_state(S),
	start.

compileAll:-
	use_module(os),
	use_module( thisProlog                  ,[prolog_version/1,
						  savedOn/2,
						  gen_tmp_files/0,
						  save_state/0,
						  save_state/1
						  ]),
	ensure_loaded(oo),
	os(OS),
	format('***Compiling Saturate for ~p~n',[OS]),
	use_module( classExpansion,[ex/0]),
	ex,
       	use_module( adt_flag,[set_default_flags_as_on_flags/0]),
	use_module( props   ,[option/1,ordering/1,ordering/2,theory/1]), % used in initialize
	ensure_loaded( initialize                  ),
	use_module(mylists,[is_list/1]),             % @|#*
      	use_module( commands 		           ),
	use_module( softtypes ),
	mylists:compile(mylists).                    % this time with expansion for append !@|#*

