:- use_module(lpbineq).
:- use_module(interface).
:- use_module(library(lists)).
:- ensure_loaded(operators).

:- multifile
        user:term_expansion/2,
        user:goal_expansion/3.

user:term_expansion(?-(Query),?-(ExpandedQuery)) :-
	(var(Query) ->
	    ExpandedQuery = Query
	;	    
	    (member(Query,[end_of_file,halt,trace,notrace]) ->
		ExpandedQuery = Query
	    ;
		ExpandedQuery = time_query(Query)
	    )
	),
	pb_init.

time_query(Query) :-
	statistics(runtime,[T,_]),
	(call(Query),
	 write_statistics(T)
	;
	 write_statistics(T),
	 fail
	).

write_statistics(T) :- 	    
	statistics(runtime,[TT,_]),
	Time is TT-T,
	format("Time used : ~w msecs ~n",[Time]),
	pb_getnocovers(NoCovers),
	pb_getnonodes(NoNodes),
	pb_getnofixed(NoFixed),
	format("pB solver statistics :  ~w Covers / ~w Nodes / ~w Fixed ~n",[NoCovers,NoNodes,NoFixed]).



