#include "intlist.h"

extern "C" {
#include "stdio.h"
#include "stdlib.h"
}

#define MAX_INTLIST_LENGTH 32768

// communicate integer lists between C++ and SICStus3
int intlist[MAX_INTLIST_LENGTH];
int intlistlength = 0;

SP_term_ref intlist2term()
{
  if (intlistlength <= 0)
    {
      return SP_new_term_ref(); // return nil
    }
  else
    {
      SP_term_ref list = SP_new_term_ref(); // list is nil
      SP_term_ref integer = SP_new_term_ref();
      int i=intlistlength-1;
      while(i >= 0)
	{
	  SP_put_integer(integer,(long) intlist[i]);
	  SP_cons_list(list,integer,list); 
	  i--;
	}
      return list;
    }
}

int term2intlist(SP_term_ref list)
{
  int i = 0;
  long integer;
  SP_term_ref head = SP_new_term_ref();
  
  while(!SP_is_atomic(list)) // nil assumed as only possible atom
    {
      if (!SP_is_list(list))
	{
	  fprintf(stderr,"term2intlist : no list!");
	  return 0;
	}
      SP_get_list(list,head,list);
      SP_get_integer(head,&integer);
      intlist[i++] = integer;
//      fprintf(stderr,"%d ",intlist[i-1]);fflush(stderr);
    }
  intlist[i] = 0;
  intlistlength = i;
/*
  fprintf(stderr,"t2il : received ");
  for(i=0; i < intlistlength;i++)
    {
      fprintf(stderr,"%d ",intlist[i]);
    }
  fprintf(stderr,"\n");
*/
  return 1;
}

