%declarations%

:- module(hgstuff, [ 
	setof0/3,
	apply/4,
	split/4,
	time/2,
	try/1,
	unzip/3,
        while/2,
        zip/3
   ]).

:-meta_predicate setof0(+,:,-).
:-meta_predicate apply(:,+,+,-).
:-meta_predicate try(:).
:-meta_predicate while(:,:).
:-meta_predicate split(:,+,-,-).
%:-meta_predicate memo(+,+,+,:).

:- use_module(global_vars, [
	cont/2,
	store/2
   ]).


%end%

% combinators


unzip([],[],[]).
unzip([K-I|X],[K|Y],[I|Z]):-
	unzip(X,Y,Z).

zip([],[],[]).
zip([K-I|X],[K|Y],[I|Z]):-
	zip(X,Y,Z).




% higher-order


setof0(E,P,S):-
	setof(E,P,S),
	!.
setof0(_,_,[]).




apply(M:P,A,B,C):-
	!,
	Call=..[P,A,B,C],
	M:Call.
apply(P,A,B,C):-
	Call=..[P,A,B,C],
	Call.


try(P):-
	(P;true),
	!.

while(P,Q):-
	(\+ \+ P ->
	     Q,
	     while(P,Q)
	;
	     true
	).

split(_,[],[],[]).
split(M:P,[X|Xs],Ys,Ns):-
	split(M:P,Xs,Ys1,Ns1),
	P=..[Pred|Args],
	Call=..[Pred,X|Args],
	
	(M:Call ->
	     Ys=[X|Ys1],
	     Ns=Ns1

	;
	     Ys=Ys1,
	     Ns=[X|Ns1]
	).
	

time(Goal,T):-
        statistics(runtime,[T1,_]),
	Goal,
	statistics(runtime,[T2,_]),
	T is (T2-T1)/1000.
