
% interreduction is outdated; now we check whether or not an inference
% is simplifying and delete premises of simplifying inferences


/* ------------------------------------------------------------------------------

Interreduction of active equations by a newly selected passive equation

------------------------------------------------------------------------------ */


interreduce(S,E,Irred_active,Red_active,Deleted):-
	active(S,ActiveST),
	init_empty(S_aux,ActiveST),
	add_active(S_aux,S_from_E,E),
	add_active(S,S_plus_E,E),
	lhs_size(E,ES),
	findall(Ru,(   unify_rule(_L,ActiveST,eq(_,Ru)),
		       not_too_small(Ru,ES)
		   ),ActiveRules),
	log(current_rules,['$listnl'(ActiveRules)]),
	active(S_from_E,RsS_from_E),
	active(S_plus_E,RsS_plus_E),
	interred(RsS_from_E,RsS_plus_E,
		 ActiveRules,ActiveST,Irred_active,[],Red_active,Deleted).


% If an equation is not reductive, ActiveRules contains both
% orientations of it. Therefore if we get to check the right
% side for reducibility we know its the smaller one.
interred(RsS,RsSPE,
	 [Ru|ActiveRules],ActiveST,Irred_active,Red_active,Red_active_all,Del/End):-
	% the left side of Ru is a maximal term
	left(Ru,L),
	(normalform1(L,LReduced,Used/[],RsS) -> 
	    number(Ru,N),
	    delete_rule(Ru,ActiveST,Active1),

	    % building reduced equation
	    right(Ru,R),
	    type(Ru,T),
	    mk_equation(LReduced,R,T,inference(reduction,eq(N),Used),Ru1),

	    interred(RsS,RsSPE,ActiveRules,Active1,
		     Irred_active,[Ru1|Red_active],Red_active_all,Del/[N|End])
	
	;(	orientation(Ru,lr),
		right(Ru,R),
		normalform1(R,RReduced,Used/[],RsSPE)
	 ) ->
	    % the rule is replaced by its (right-)reduced form
	    % no recomputation of CPs take place
	    proof(Ru,P),
	    Proof=inference(reduction,P,Used),  % number of reduced equation not changed
	    delete_rule(Ru,ActiveST,Active1),
	    proof(Ru,Ru1,Proof),
	    right(Ru1,Ru2,RReduced),
	    rsize(Ru2,Ru3,_),         % invalidate rsize
	    add_rule(Active1,Active2,Ru3),
	    
	    interred(RsS,RsSPE,ActiveRules,Active2,
			 Irred_active,Red_active,Red_active_all,Del/End)
	
	;% equation irreducible
	    interred(RsS,RsSPE,ActiveRules,ActiveST,
		     Irred_active,Red_active,Red_active_all,Del/End)
	).
interred(_S,_SPE,[],Active,Active,Red_active,Red_active,Del/Del).
	% all rules remaining in Active are irreducible
	
