
:- module(dynamicCode,[

       recordPrologClause/2,
       recordProp/1,
       initialize/0,
       known_proposition/1

   ]).



:- use_module(thisProlog, [compile_nqa/2]).
:- use_module(global, [cont/2]).

:- dynamic clause/1, prop/1.





known_proposition(_):-
	fail.


initialize:-
	retract(clause((H:-_B))),
	functor(H,P,N),
	abolish(P,N),
	fail.
initialize:-
	retractall(prop(_)),
	abolish(known_proposition,1).


	
	       

recordPrologClause(true,Props):-
	!,
	maplist(recordProp,Props),
	recompile.
recordPrologClause(C,Props):-
	assertz(clause(C)),
%	nl,portray_clause(C),nl,
	maplist(recordProp,Props),
	recompile.

recordProp(P):-
	functor(P,F,_),
	prop(F),
	!.
recordProp(P):-
	functor(P,F,_),
	assertz(prop(F)).

recompile:-
	cont(props_tmp_file,F),
	tell(F),
	clause(C),
	portray_clause(C),
	fail.
recompile:-
	prop(C),
	portray_clause(known_proposition(C)),
	fail.
recompile:-
	told,
	cont(props_tmp_file,F),
	compile_nqa(dynamicCode,F).


