% -*- Module: os; -*-

:-module(os,[command_name/2,unix2os/2]).


:-use_module(library(maplist),[maplist/3]).


command_name(C,N):-
	(user:os(windows) ->
	     w_command(C,N)
	;
	     u_command(C,N)).


w_command(cat,"cat ").
w_command(ls,"bash -c ls").
w_command(cp,"copy ").

u_command(cat,"cat ").
u_command(ls,"ls ").
u_command(cp,"cp ").




unix2os(C1,C2):-
	user:os(windows),
	!,
	name(C1,C1N),
	maplist(slash2backslash,C1N,C2N),
	name(C2,C2N).
unix2os(C,C).


slash2backslash(S,B):-
	name('/',[S]),
	name('\\',[B]),   % escape character!
	!.
slash2backslash(X,X).
