:- module(thisProlog, [ 
	command_exists/1,
	file_exists/1,
	gen_tmp_files/0,
	gen_tmp_file/2,
	save_state/0,
	save_state/1,
	savedOn/2,
	shell/1,
	portray_clause2/2,
	prolog_version/1,
	my_absolute_file_name/2,
	compile_nqa/2,
	timeOut/3,
	tryAShortTime/1
   ]).

:- meta_predicate timeOut(:,+,-).
:- meta_predicate tryAShortTime(:).

:- dynamic savedOn/2.

/*
compile_nqa(M,F) (``no questions asked'')
allows compilation of predicates from arbitrary files F
into arbitrary modules M
without having to answer any query about redefinition on
the top level.

*/

:-dynamic prolog_version/1.

timeOut(A,B,C):-
	time_out(A,B,C).

prolog_version(Version):-
	prolog_flag(version,V),
	name(V,VN),
	(user:append1("SICStus 2",_,VN) ->
	     Version=sicstus
	;user:append1("SICStus 3",_,VN) ->
	     Version=sicstus3
	;
             name('Quintus Prolog ',QN),
	user:append1(QN,VN,QVN),
	!,
	name(Version,QVN)),
	asserta((prolog_version(Version):- !)).


portray_clause2(S,C):-
	(\+prolog_version(sicstus3) ->
	     current_output(O),
	     set_output(S),
	     portray_clause(C),
	     set_output(O)
	;
	     portray_clause(S,C)
	).


:-
	(prolog_version(sicstus) ->
	    ensure_loaded(sicstus)
	;prolog_version(sicstus3) ->
	    ensure_loaded(sicstus3)
	;
            ensure_loaded(quintus)
	).



my_absolute_file_name(F,FA):-
	(F=..[D,FF],
	 user:file_search_path(D,Path) ->
	     auxiliary:appendAtoms([Path,FF],'/',FA)
	;
	     F=FA
	).


tryAShortTime(P):-
	timeOut(P,2000,S),
	!,
	(S=success ->
	     true
	;
	     write('%'),
	     fail
	).


%tryAShortTime(P):- P.
